#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h> //structures
#include <netdb.h>      //gethostbyname
#include <unistd.h>		//non-blocking
#include <fcntl.h>		//non-blocking
#include <string.h>	//memset, memcpy
	int seq=300;
////////////////////////////////////////////
///		UTIL
////////////////////////////////////////////
int makelong(char hi, char lo)
{
	return (hi*256)+lo;
}

char hi(int n)	
{				
	return n/256;  
}

char lo(int n)
{
	return n%256;
}

void delay(int cycles)
{
	cycles*=1000000;
	for(cycles;cycles>0;cycles--){}
}


////////////////////////////////////////////
///		SOCK
////////////////////////////////////////////
	int sock;	//the socket file descriptor

int aconnect(char *addr, int port)
{
	struct hostent *h; //this is just used as an intermediate to get the IP
	struct sockaddr_in serv;	//stores our connection properties
	memset((char *)&serv,0,sizeof(serv));	//clear struct
	if((h=gethostbyname(addr))==NULL) return 0;	//get the IP
	memcpy(&(serv.sin_addr.s_addr),h->h_addr,h->h_length);	//set the IP
	serv.sin_family = AF_INET;
	serv.sin_port = htons(port);	//host to network byte order conversion
	if((sock = socket(AF_INET, SOCK_STREAM, 0))==-1) return 0; 
	if(connect(sock, (struct sockaddr *)&serv, sizeof(struct sockaddr))==-1)
	       	return 0;
	fcntl(sock, F_SETFL,O_NONBLOCK);	//Set non-blocking mode
	return 1;		//successful connect
}

int asend(string msg)
{
	if(send(sock,msg.str,msg.len,0)==-1) 
	{
		fprintf(stderr,"Error on send()");
		return 0;
	}
	return 1;
}

void arecv(string &msg)
{
	msg.len = recv(sock,msg.str,2048,0);
	if (msg.len == -1) 
	{
		msg.len = 0;
		fprintf(stderr,"Error on recv()");
	}
	//msg.str[nRet]=0;	//should be there anyway
}

void adone()
{
	close(sock);
}


////////////////////////////////////////////
///		GET
////////////////////////////////////////////
int snaclen()
{
	string msg(6);
	int nRet=recv(sock,msg.str,1,0);
	if(nRet==-1) return 0;
	fcntl(sock,F_SETFL,O_SYNC);
	recv(sock,msg.str+1,5,0);
	fcntl(sock,F_SETFL,O_NONBLOCK);
	return makelong(msg[4],msg[5]);
}

int checksnac(string &msg)	//tries to recv a snac
{
	msg.len=snaclen();
	if(msg.len==0) return 0;
	fcntl(sock,F_SETFL,O_SYNC);
	recv(sock,msg.str,msg.len,0);
	fcntl(sock,F_SETFL,O_NONBLOCK);
	msg[msg.len]=0;
	return 1;	//got a snac
}

void recvsnac(string &msg)
{
	while(!checksnac(msg)){}
}


////////////////////////////////////////////
///		PUT
////////////////////////////////////////////
int sendflap(char frame, string msg)
{
	int len=msg.len;
	if(len>2048) return 0;
	if(seq==65535) seq=0;
	else seq++;
	string head('*',frame,hi(seq),lo(seq),hi(len),lo(len));
	if(frame==1) asend(head+msg);
	if(frame==2) asend(head+msg);
	return 1;
}

void sendsnac(string msg)
{
	msg+=char(0);	//ONLY FOR TOC !!!!!!!!!!!!!!!!!!!
	sendflap(2,msg);
}

int sendim(string sn, string rtfsend)
{
	if(rtfsend[0]!=0&&rtfsend.len<2049)
	{
		if(sendflap(2,"toc_send_im "+sn+" \"<html>"+rtfsend+"</html>\""+char(0))) return 1;
	}
	return 0;
	
}


////////////////////////////////////////////
///		LOGIN
////////////////////////////////////////////

char* roast(char *pass)		//code from GAIM
{
	// Trivial "encryption" 
	static char rp[256];
	static char *roast = "Tic/Toc";
	int pos=2;
	int x;
	strcpy(rp, "0x");
	for (x=0;(x<150) && pass[x]; x++) 
		pos+=sprintf(&rp[pos],"%02x", pass[x] ^ roast[x % strlen(roast)]);
	rp[pos]='\0';
    return rp;
}

int login(string sn, string pw)
{
	string buf(10000);
	pw=roast(pw.str);
	if(aconnect("toc.oscar.aol.com",5190)==0)
	{
		fprintf(stderr,"Connect failed!");
		return 0;
	}
	string flap="FLAPON\r\n\r\n";
	asend(flap);
	recvsnac(buf);
	printf("%x %x %x %x\n", buf[0],buf[1],buf[2],buf[3]);
	
	string signon(0,0,0,1,0,1);
	signon+=char(0);
	signon+=char(sn.len);
	signon+=sn;
	signon+=char(0);
	sendflap(1,signon);


	string msg="toc_signon login.oscar.aol.com 5190 "+sn+" "+pw+" english \"AOLInstantMessenger\"";
	msg+=char(0);
	sendflap(2,msg);

	recvsnac(buf);
	printf("%s\n",buf.str);
	
	recvsnac(buf);
	printf("%s\n",buf.str);

	string add="toc_add_buddy "+sn;
	add+=char(0);
	sendflap(2,add);

	string info="toc_set_info \"<html><body bgcolor=000000><font color=0000FF face='matisse ITC'>AIM CLIENT on AIM FORTRESS<br><br><font size=3 color=FF0000 face='small fonts'>chris clark / bill orr bringin the warez</font></font><br><br><br><br><br><br></body></html>\"";
	info+=char(0);
	sendflap(2,info);

	string done="toc_init_done";
	done+=char(0);
	sendflap(2,done);
	
	recvsnac(buf);
	printf("%s\n",buf.str);
	return 1;
}


