//maim - AIM Mathematica front-end
//remember to add a username lock so that only one person can
//use it at a time so that they can safely use the history

#include <stdio.h>
#include "mathlink.h"
#include "string.cpp"
#include "clfunc.cpp"
#include <sys/ioctl.h>  //ioctl

void ParseIM(string IM_IN, char *screenname, char *msgtext)
{
	int index=0,html=0,loc;
	char *IM=IM_IN.str;
	while(IM[index++]!=':') {}
	loc=index;
	while(IM[++index]!=':') {}
	IM[index]=0;	//null terminate screenname string
	strcpy(screenname,IM+loc);
	index+=3;	//skip F:
	while(1)
	{
		if(IM[index]=='<') ++html;
		else if(IM[index]=='>') --html;
		else if(html==0) break;
		++index;
	}
	loc=index;	//start of actual text
	while(IM[++index]!='<') {}
	IM[index]=0;	//null terminate message text
	strcpy(msgtext,IM+loc);
}

void EscapeBrackets(char *str)
{
	int i,find,len=strlen(str)+1; //include null
	for(i=0;i<len;++i)
	if(str[i]=='[')
	{
		find=i;
		for(i=len;i>find;--i) str[i]=str[i-1];
		++len;
		str[find]='\\';
		i=find+2;
	}

}

void KillWhiteSpace(char *str)
{
	int i,loc,len=strlen(str);
	for(i=0;i<len;++i)
	if(str[i]==' ')
	{
		loc=i;
		for(;i<len;++i) str[i]=str[i+1];
		i=loc;
	}
}

void showValues(char *buffer, int length)
{
	int index;
	for(index=0;index<length;++index) printf("%i ",buffer[index]);
	printf("\n");
}

int main(int argc, char *argv[])
{
	string IM(2048);
	char screenname[32];
	char command[2048];
	char result[2048];
	const char *result_ptr;
	const char **result_ptr_ptr = &result_ptr;
	MLINK stdlink;
	MLEnvironment env;
	
//-LinkMode Connect -LinkName "4649@machine.domain.com" -LinkProtocol TCP
	
	char *LinkArgs[]={"-LinkMode","Connect","-LinkName",argv[1],
			"-LinkProtocol","TCP",NULL};
	
	env = MLInitialize(NULL); if(!env) return 1;
	stdlink = MLOpen(6, LinkArgs); if(!stdlink) return 2;
	if(!MLConnect(stdlink)) return 3; //just verifies connection
	printf("Link Established to %s\n", argv[1]);
		
	if(login("onsmirnt","harrycroto")==1)
		printf("Connected as %s\n","onsmirnt");
	else return 4;
	delay(100);
	
	while(1)
	{
		while(checksnac(IM)!=1) sleep(1);
		if(IM[0]!='I' || IM[1]!='M') continue;
		printf("Incoming Message: ");
		ParseIM(IM,screenname,command);
		printf("User: %s Command: %s\n",screenname,command);
		MLPutFunction(stdlink, "EvaluatePacket", 1);
		MLPutFunction(stdlink, "ToString", 2);
		MLPutFunction(stdlink, "ToExpression", 1);
		MLPutString(stdlink, command);
		MLPutFunction(stdlink, "ToExpression", 1);
		MLPutString(stdlink, "InputForm");
		MLEndPacket(stdlink);
		while(MLNextPacket(stdlink)!=RETURNPKT) MLNewPacket(stdlink);
		MLGetString(stdlink, result_ptr_ptr); 
		strcpy(result,result_ptr);
		printf("Out: %s\n",result);
		EscapeBrackets(result);
		KillWhiteSpace(screenname);
		sendim(screenname,result);
		sleep(1);
		MLDisownString(stdlink, result_ptr);
		MLNewPacket(stdlink);	//just to be sure its done
	}

	MLClose(stdlink);
	MLDeinitialize(env);
	adone();	//logoff AIM
	return 0;
}
